#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Maroon
#property indicator_color5 Red
#property indicator_color6 Lime
#property indicator_level1 0
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor PaleVioletRed




extern int    TimeFrame_Shift      = 1;
//extern string TimeFrame            = "Current time frame";
extern int    LRegrPeriod          = 50;
extern double Phase                =  0;
extern int    Lag                  = 20;
extern int    NumberOfComputations = 2;
extern int    NumberOfBars         = 500;
extern int    Price                = PRICE_CLOSE;
extern bool   DataDisplayOff       = false;
extern bool   Interpolate          = true;
extern bool   alertsOn             = false;
extern bool   alertsOnCurrent      = true;
extern bool   alertsMessage        = true;
extern bool   alertsSound          = false;
extern bool   alertsEmail          = false;

//
//
string TF1;
//
//

double upB[];
double upB2[];
double loB[];
double loB2[];
double upK[];
double loK[];
double value[];
double trend[];
int tfs[9];
//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
//int    TimeFrame_Shift;

//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,upB);
      SetIndexBuffer(1,loB);  
      SetIndexBuffer(2,upB2); 
      SetIndexBuffer(3,loB2);
      SetIndexBuffer(4,upK);
      SetIndexBuffer(5,loK);
      SetIndexBuffer(6,value);
      SetIndexBuffer(7,trend);

      //
      //
      //
      //
      //
   
      if (DataDisplayOff)
      {
         SetIndexStyle(0,DRAW_NONE);
         SetIndexStyle(1,DRAW_NONE);
         SetIndexStyle(2,DRAW_NONE);
         SetIndexStyle(3,DRAW_NONE);
         SetIndexStyle(4,DRAW_HISTOGRAM,EMPTY,2);
         SetIndexStyle(5,DRAW_HISTOGRAM,EMPTY,2);
      }
      else
      {
         SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,4);
         SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,4);
         SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,4);
         SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,4);
         SetIndexStyle(4,DRAW_ARROW,EMPTY,2); SetIndexArrow(4,159);
         SetIndexStyle(5,DRAW_ARROW,EMPTY,2); SetIndexArrow(5,159);
      }     

      //
      //
int itf = 0;
   
   tfs[0] = 1;
   tfs[1] = 5;
   tfs[2] = 15;
   tfs[3] = 30;
   tfs[4] = 60;
   tfs[5] = 240;
   tfs[6] = 1440;
   tfs[7] = 10080;
   tfs[8] = 43200;
   
   for( int i = 0; i < 9; i++ ) {
      if( Period() == tfs[i] )
         itf = i;
   }
   
   if( itf + TimeFrame_Shift > 8 ) {
      itf = Period();
      TimeFrame_Shift = 0;
   }
      
   
   TimeFrame_Shift = tfs[itf+TimeFrame_Shift];

      //
      //
   switch(TimeFrame_Shift)
	{
		case 1:		TF1="M1";  break;
		case 5:		TF1="M5";  break;
		case 15:		TF1="M15"; break;
		case 30:		TF1="M30"; break;
		case 60:		TF1="H1";  break;
		case 240:	TF1="H4";  break;
		case 1440:	TF1="D1";  break;
		case 10080:	TF1="W1";  break;
		case 43200:	TF1="MN1"; break;
		default:	  {TimeFrame_Shift = Period(); init(); return(0);}
	}
	    //
	    //
         
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame_Shift=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame_Shift=="returnBars");     if (returnBars)     return(0);
      TimeFrame_Shift   = stringToTimeFrame (TimeFrame_Shift);
   
      //
      //
      //
      //
      //
      
  IndicatorShortName(" ssa squeeze of double smooth jurik "+timeFrameToString(TimeFrame_Shift)+","+LRegrPeriod+")"); 
   
   return(0);
  }
  
  
int deinit(){return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
  {
   
   
   double diff,d,dPrev, std,bbs;
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMax(MathMin(Bars-counted_bars,Bars-1),Lag);
         if (returnBars) { upB[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //

   if (calculateValue || TimeFrame_Shift==Period())
   {   
      for(i=limit;i>=0;i--)
      {
      
         d=LinearRegressionValue(LRegrPeriod, i);
         dPrev=LinearRegressionValue(LRegrPeriod,i+1);
      
         value[i] = d;      
         if(d>0) {
            if ((dPrev>0) && (dPrev > d)){ upB2[i]=d; upB[i] = 0; } else { upB[i]= d; upB2[i] = 0; }
        
            loB[i]=0;
            loB2[i]=0;
         
         } else {
      
            if ((dPrev<0) && (dPrev < d)){ loB2[i]=d; loB[i] = 0; } else { loB[i]= d; loB2[i] = 0; }
            upB[i]=0;
            upB2[i]=0;
  
         }
      
         diff = iCustom(NULL,0,"SSA of price",Lag,NumberOfComputations,NumberOfBars,Price,0,i);
         std =  iCustom(NULL,0,"SSA of price",Lag,NumberOfComputations,NumberOfBars,Price,0,i+1);
         bbs = diff-std;
		
         trend[i] = trend[i+1];
            if(bbs > 0) trend[i] =  1;
            if(bbs < 0) trend[i] = -1;
   		if (DataDisplayOff)
         {
            if(bbs < 0) {
               upK[i] = 10;
               loK[i] = EMPTY_VALUE;
            } else {
               loK[i] = 10;
               upK[i] = EMPTY_VALUE;
            }
		   }
         else
		   {
            if(bbs < 0) {
               upK[i] = 0;
               loK[i] = EMPTY_VALUE;
            } else {
               loK[i] = 0;
               upK[i] = EMPTY_VALUE;
            }
         }         
      }
      manageAlerts();
      return(0);
  }
  
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,TimeFrame_Shift,indicatorFileName,"returnBars",0,0)*TimeFrame_Shift/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame_Shift,Time[i]);
         upB[i]     = iCustom(NULL,TimeFrame_Shift,indicatorFileName,"calculateValue",LRegrPeriod,Phase,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,0,y);
         loB[i]     = iCustom(NULL,TimeFrame_Shift,indicatorFileName,"calculateValue",LRegrPeriod,Phase,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,1,y);
         upB2[i]    = iCustom(NULL,TimeFrame_Shift,indicatorFileName,"calculateValue",LRegrPeriod,Phase,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,2,y);
         loB2[i]    = iCustom(NULL,TimeFrame_Shift,indicatorFileName,"calculateValue",LRegrPeriod,Phase,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,3,y);
         upK[i]     = iCustom(NULL,TimeFrame_Shift,indicatorFileName,"calculateValue",LRegrPeriod,Phase,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,4,y);
         loK[i]     = iCustom(NULL,TimeFrame_Shift,indicatorFileName,"calculateValue",LRegrPeriod,Phase,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,5,y);
         value[i]   = iCustom(NULL,TimeFrame_Shift,indicatorFileName,"calculateValue",LRegrPeriod,Phase,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,6,y);
         trend[i]   = iCustom(NULL,TimeFrame_Shift,indicatorFileName,"calculateValue",LRegrPeriod,Phase,Lag,NumberOfComputations,NumberOfBars,Price,DataDisplayOff,7,y);
               
         //
         //
         //
         //
         //
                        
         if (!Interpolate || y==iBarShift(NULL,TimeFrame_Shift,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame_Shift,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(int k = 1; k < n; k++)
            {
               value[i+k] = value[i] + (value[i+n]-value[i])*k/n;
               if (loB[i]!=0)  loB[i+k]  = value[i+k];
               if (loB2[i]!=0) loB2[i+k] = value[i+k];
               if (upB[i]!=0)  upB[i+k]  = value[i+k];
               if (upB2[i]!=0) upB2[i+k] = value[i+k];
            }
   }
   manageAlerts();
   return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,TimeFrame_Shift,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(TimeFrame_Shift)+" ssa squeeze trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ssa squeeze "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double LinearRegressionValue(int Len,int shift) {

   double calcLRegrPeriod = MathSqrt(LRegrPeriod);
   double SumBars = 0;
   double SumSqrBars = 0;
   double SumY = 0;
   double Sum1 = 0;
   double Sum2 = 0;
   double Slope = 0;

   SumBars = Len * (Len-1) * 0.5;
   SumSqrBars = (Len - 1) * Len * (2 * Len - 1)/6;

  for (int x=0; x<=Len-1;x++) {
   double HH = High[x+shift];
   double LL = Low[x+shift];
   for (int y=x; y<=(x+Len)-1; y++) {
     HH = MathMax(HH, High[y+shift]);
     LL = MathMin(LL, Low[y+shift]);
   }
    Sum1 += x* (Close[x+shift]-((HH+LL)/2 + iDSmooth(iMA(NULL,0,1,0,MODE_SMA,0,x+shift),calcLRegrPeriod,Phase,x+shift, 0))/2);
    
    SumY +=    (Close[x+shift]-((HH+LL)/2 + iDSmooth(iMA(NULL,0,1,0,MODE_SMA,0,x+shift),calcLRegrPeriod,Phase,x+shift,20))/2);
  }
  Sum2 = SumBars * SumY;
  double Num1 = Len * Sum1 - Sum2;
  double Num2 = SumBars * SumBars-Len * SumSqrBars;

  if (Num2 != 0.0)  { 
    Slope = Num1/Num2; 
  } else { 
    Slope = 0; 
  }

  double Intercept = (SumY - Slope*SumBars) /Len;
  double LinearRegValue = Intercept+Slope * (Len - 1);

  return (LinearRegValue);

}


double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, int i, int s=0)
{
   return (iSmooth(iSmooth(price,length,phase,i,s),length,phase,i,s+10));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}